#
# Makefile Template for Tessy
# Compiler: Green Hills V850
# Debugger: Green Hills MULTI 2000
# Template Version: 2
#

# Defines to be generated by Tessy:
#
# BUFFER_SIZE           :=
# COMPILER_DEFINES      :=
# COMPILER_INCLUDES     :=
# COMPILER_INSTALL_PATH :=
# CPU                   :=
# COMPILER_DEFINES      :=
# COMPILER_INCLUDES     :=
# COMPILER_INSTALL_PATH :=
# ENDIANESS             :=
# EXEFILE_EXTENSION     :=
# LINKER_FILE           :=
# MODULE_PATH           :=
# MODULE_PATH_DOS       :=
# OBJFILE_EXTENSION     :=
# PROJECTROOT           :=
# TARGET_INSTALL_PATH   :=
# TESSY_BIN             :=
# TESSY_SYS             :=
# TESTOBJECT            :=
# TIMER_FILE            :=
# TARGET_INSTALL_PATH   :=
# TIMER_FILE            :=
# USER_LINK_OPTIONS     :=

#####################################################################
#BEGIN_DEFINES
#####################################################################

#
# Special macros for includes and defines
#
TS_DEF_SEPARATOR :=-D
define TS_DEFINE
$(subst ;, $(TS_DEF_SEPARATOR),$(1))
endef

TS_INC_SEPARATOR :=-I
define TS_INCLUDE
$(subst ;, $(TS_INC_SEPARATOR),$(1))
endef


TESSY_SYS_DOS		:=	$(shell ts_pathname -s $(TESSY_SYS))
GHSV850_HOME		:= $(shell ts_pathname -s '$(COMPILER_INSTALL_PATH)')

all	 : master slave
master : $(MODULE_PATH)/ts_$(TESTOBJECT)_m.exe
#if rec is needed
#slave  : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s.rec
slave  : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s$(EXEFILE_EXTENSION)

#
# MASTER & COMM Makefiles
# (you should not need to modify these settings)
#
M_COMM_MAKE		:=	$(TESSY_SYS)/make/master_multi_gnu_i386.mk
S_COMM_MAKE		:=	$(TESSY_SYS)/src/comm/comm_multi_ghs_v850.mk

ifeq ($(COMPILER_DIALECT),)
	COMPILER_DIALECT := -c99
endif

#
# SLAVE
# (You may change these settings to use your own compiler/linker options)
#
S_COMP_OPTIONS	:=	-layout=ram -bsp=generic -w -G -full_debug_info -cpu=$(CPU) -Ogeneral \
                  --preprocess_linker_directive -ffunctions -sda -large_sda -e _RESET -Mn $(COMPILER_DIALECT) \
                  -fsoft -DTESSY -DTS_SLAVE -DTS_MULTI -DTS_V850 -DTS_HAVE_FLOAT64 -DTS_HAVE_INT64
				
S_LINK_OPTIONS	:= -T$(LINKER_FILE) -map=$(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s.map
S_DBL_OPTIONS	:=	-nm=auto $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s
#
# Activate DBL options if required.
#S_DBL_STDLIB_OPTIONS	:=  $(GHSV850_HOME)\lib\$(CPU)\crt0.dbo $(GHSV850_HOME)\lib\$(CPU)\libstartup.dba $(GHSV850_HOME)\lib\$(CPU)\libsys.dba \
#                                         $(GHSV850_HOME)\lib\$(CPU)\libind.dba $(GHSV850_HOME)\lib\$(CPU)\libarch.dba \
#                                         $(GHSV850_HOME)\lib\$(CPU)\libansi.dba $(GHSV850_HOME)\lib\$(CPU)\libmulti.dba
S_INCLUDES		:= -I$(TESSY_SYS_DOS)\include\tessy\comm -I$(MODULE_PATH_DOS)

S_CC				:=	$(GHSV850_HOME)\cc$(CPU)
S_LINK			:=	$(GHSV850_HOME)\elxr
S_DBL				:=	$(GHSV850_HOME)\dblink  $(S_DBL_STDLIB_OPTIONS)
S_LIB_PATH		:=	$(GHSV850_HOME)\lib\$(CPU)
S_LIBS			:= -L $(S_LIB_PATH)	-lmulti -lansi -lind_sf -lstartup -lsys -larch -lfmalloc -lwchar_s32 -lwc_s32
S_OBJECTS  		:= $(MODULE_PATH_DOS)\tslows_multi.o \
             		$(MODULE_PATH_DOS)\tstcomm.o \
             		$(MODULE_PATH_DOS)\tscoml.o
S_STUB_OBJECT  := $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_stubs.o
S_UC_OBJECT    := $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_usr.o
S_HEX          := $(GHSV850_HOME)\gsrec -e 0 -noS5

#####################################################################
#END_DEFINES
#####################################################################

#####################################################################
#BEGIN_SOURCE
#####################################################################

#
# Template rules
#
$(MODULE_PATH_DOS)\ts_src$$(SOURCENUMBER)$(OBJFILE_EXTENSION): $(MODULE_PATH_DOS)\ts_src$$(SOURCENUMBER).c
	$(S_CC) $(S_INCLUDES) $(call TS_INCLUDE,$(USER_INCLUDES$$(SOURCENUMBER))) $(S_COMP_OPTIONS) \
		$(call TS_DEFINE,$(USER_DEFINES$$(SOURCENUMBER))$(S_COM_OPTIONS)) \
		$(USER_COMP_OPTIONS$$(SOURCENUMBER)) -o $@ -c "$<"


#####################################################################
#END_SOURCE
#####################################################################

#####################################################################
#BEGIN_TARGETS
#####################################################################


# COMPILE USERCODE / STUBS
#
$(S_UC_OBJECT) : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_usr.c
	$(S_CC) $(S_INCLUDES) $(S_COMP_OPTIONS) -o $@ -c $<

$(S_STUB_OBJECT) : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_stubs.c
	$(S_CC) $(S_INCLUDES) $(S_COMP_OPTIONS) -o $@ -c $<


#
# COMPILE/LINK MASTER
#

include $(M_COMM_MAKE)


#
# COMPILE SLAVE COMMUNICATION MODULES

include $(S_COMM_MAKE)



#
# COPY LINKER FILES
#
#	WS	$(MODULE_PATH_DOS)\memory.ld : $(LINKER_FILE)
#	WS		@echo ***** Copying Linker File *****
#	WS		@ts_cp $< $@


#
# COMPILE/LINK SLAVE
#
$(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s$(OBJFILE_EXTENSION) : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s.c
	@echo *
	@echo ***** Compiling Slave *****
	$(S_CC) $(S_COMP_OPTIONS) $(S_INCLUDES) -o $@ -c $<


#
# Handle Board Files
#
ifeq ("true","$(USE_BOARD_FILES)")
ifeq ("","$(INITOBJDIR)")
$(error Attribute 'Use Board Files' is set to true but 'InitObjDir' is empty.)
endif
INITOBJDIR := $(shell ts_pathname -s '$(INITOBJDIR)')
ifeq ("","$(INITSRCDIR)")
$(info Attribute 'InitSrcDir' is empty. Using objects for linking only.)
START_OBJS := $(wildcard $(INITOBJDIR)/*$(OBJFILE_EXTENSION))
else
INITSRCDIR := $(shell ts_pathname -s '$(INITSRCDIR)')
START_OBJS := $(patsubst $(INITSRCDIR)/%.c,$(INITOBJDIR)/%$(OBJFILE_EXTENSION),$(wildcard $(INITSRCDIR)/*.c)) \
              $(patsubst $(INITSRCDIR)/%.850,$(INITOBJDIR)/%$(OBJFILE_EXTENSION),$(wildcard $(INITSRCDIR)/*.850))

$(INITOBJDIR)/%$(OBJFILE_EXTENSION) : $(INITSRCDIR)/%.c
	$(S_CC) $(S_COMP_OPTIONS) $(S_INCLUDES) -I$(INITSRCDIR) -c "$<" -o "$@"

$(INITOBJDIR)/%$(OBJFILE_EXTENSION) : $(INITSRCDIR)/%.850
	$(S_CC) $(S_COMP_OPTIONS) $(S_INCLUDES) -c "$<" -o "$@"
endif
ifeq ("","$(START_OBJS)")
$(warning Attribute 'Use Board Files' is set to true but no objects were found.)
endif
endif

$(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s$(EXEFILE_EXTENSION) : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s$(OBJFILE_EXTENSION) \
															$(S_SRC_OBJECTS) \
															$(START_OBJS) \
															$(S_UC_OBJECT) \
															$(S_STUB_OBJECT) \
															$(S_OBJECTS) \
															$(LINKER_FILE)

	@echo *
	@echo ***** Linking Slave *****
	$(S_LINK) -o "$@" $(S_LINK_OPTIONS) $(USER_LINK_OPTIONS) \
   $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s$(OBJFILE_EXTENSION) $(S_SRC_OBJECTS) $(S_UC_OBJECT) \
   $(S_STUB_OBJECT) $(S_OBJECTS) $(START_OBJS) $(S_LIB_PATH)\crt0$(OBJFILE_EXTENSION) $(S_LIBS)
	@-ts_rm "$(MODULE_PATH)"/*$(OBJFILE_EXTENSION)

#if rec is needed
#$(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s.rec : $(MODULE_PATH_DOS)\ts_$(TESTOBJECT)_s
#	@echo *
#	@echo ***** Create HEX file *****
#	$(S_HEX) -o "$@" "$<"
#	@ts_cp "$@" $(MODULE_PATH_DOS)\..\..\..\Config\TestFile.rec
#	@ts_cp "$@" $(TESSY_TESTAREA)\TestFile.rec

#####################################################################
#END_TARGETS
#####################################################################












